package com.yeejoin.amos.safety.business.controller;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import com.yeejoin.amos.safety.business.response.PatrolUserRespone;
import com.yeejoin.amos.safety.business.response.PointInfoSyn3DRespone;
import com.yeejoin.amos.safety.business.response.RouteResponse;
import com.yeejoin.amos.safety.business.service.ILink3DVoService;
import com.yeejoin.amos.safety.business.service.INode3DVoService;
import com.yeejoin.amos.safety.business.vo.CommonPageable;
import com.yeejoin.amos.safety.business.vo.CommonRequest;
import com.yeejoin.amos.safety.business.vo.CommonResponse;
import com.yeejoin.amos.safety.business.vo.CommonResponseUtil;
import com.yeejoin.amos.safety.business.vo.CompanyBo;
import com.yeejoin.amos.safety.business.vo.DaoCriteria;
import com.yeejoin.amos.safety.business.vo.DepartmentBo;
import com.yeejoin.amos.safety.business.vo.JSONUtil;
import com.yeejoin.amos.safety.business.vo.QueryOperatorEnum;
import com.yeejoin.amos.safety.business.vo.ReginParams;
import com.yeejoin.amos.safety.business.vo.StringUtil;
import com.yeejoin.amos.safety.common.cache.CurUserCompanyCache;
import com.yeejoin.amos.safety.common.entity.Link3DVo;
import com.yeejoin.amos.safety.common.entity.Node3DVo;
import com.yeejoin.amos.safety.common.entity.dto.CoordDTO;
import com.yeejoin.amos.safety.common.enums.CheckStateEnum;
import com.yeejoin.amos.safety.common.enums.View3DNodeType;
import com.yeejoin.amos.safety.common.view.View3DHandler;
import com.yeejoin.amos.safety.core.remote.service.AmosBankPatrol;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;

/**
 * 
 * <pre>
 * 界面视图Controller
 * </pre>
 *
 * @author amos
 * @version $Id: ViewController.java, v 0.1 2018年1月26日 上午11:00:16 amos Exp $
 */
@RestController
@RequestMapping(value = "/view3d")
@Api(value = "view3d", tags = { "三维视图API" })
public class View3DController extends BaseController
{
	@Autowired
	private INode3DVoService node3DVoService;
	 
	@Autowired
	private ILink3DVoService link3DVoService;
	
	@Autowired
	private AmosBankPatrol remotePatrolServer;
	
	private static final Logger logger = Logger.getLogger(View3DController.class);
	/**
	 * 
	 * <pre>
	 * 初始化三维视图节点
	 * </pre>
	 *
	 * @param type
	 * @return
	 */
	@GetMapping(value = "/initViewNode",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "初始化三维视图节点", notes = "初始化三维视图节点")
	public CommonResponse initViewNode(
			@ApiParam(value = "节点类型", required = false) @RequestParam(required = false) String type)
	{
		List<Node3DVo> node3DVos = null;
		boolean isAll = true;//是否查询所有与节点
		List<DaoCriteria> daoCriterias = new ArrayList<>();
		daoCriterias = buildViewDaoCriteria(daoCriterias);

//		User currUser = getUserInfo();
//		if (currUser != null)
//		{
//			Department department = currUser.getDepartment();
//			if (department != null)//部门用户
//			{
//				//通过当前登录用户orgCode过滤
//				daoCriterias = buildViewDaoCriteria(daoCriterias);
//			}else //单位用户
//				{
//				//获取当前用户所选单位
//				String compCode  = CurUserCompanyCache.getInstance().getCurCompany(getUserId(), getToken());
//				if (compCode != null)
//				{
//					//查询本单位及子单位下所有部门
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.EQUAL.getName(), compCode));
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"*%"));
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"*%"));
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"-%"));
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"-%"));
//				}else
//				{
//					//无orgCode条件，通过当前登录用户orgCode过滤
//					daoCriterias = buildViewDaoCriteria(daoCriterias);
//				}
//			}
//		}
		if (StringUtil.isNotEmpty(type))	
		{
			//查询节点类型对应的节点
			//fireResource
			DaoCriteria daoCriteria = new DaoCriteria();
			daoCriteria.setPropertyName("type");
			if("fireResource".equals(type)){
				daoCriteria.setOperator(QueryOperatorEnum.IN.getName());
				daoCriteria.setValue(Arrays.asList("hydrant","pool","fireCar","fireEquipment","fireChamber","fireFoamRoom"));
				isAll = true;
			}else if("water".equals(type)){
				daoCriteria.setOperator(QueryOperatorEnum.IN.getName());
				daoCriteria.setValue(Arrays.asList("hydrant","pool"));
				isAll = true;
			}else{
				daoCriteria.setOperator(QueryOperatorEnum.EQUAL.getName());
				daoCriteria.setValue(type);
				isAll = false;
			}
			daoCriterias.add(daoCriteria);
			
		}
		node3DVos = node3DVoService.findAll(daoCriterias);
		List<Node3DVo> node3DVosfilter = View3DHandler.getInstance().nodeDatafilter(node3DVos);  //进行数据过滤
		Map<String, List<Map<String, Object>>> viewMap = View3DHandler.getInstance()
				.buildViewNodeJson(node3DVosfilter);
		if (isAll)
		{
			return CommonResponseUtil.success(viewMap);
		}else 
		{
			List<Map<String, Object>> viewTypeList = viewMap.get(type);
			if (viewTypeList == null)
			{
				viewTypeList = new ArrayList<Map<String, Object>>();
			}
			return CommonResponseUtil.success(viewTypeList);
		}
	}
	/**
	 * 
	 * <pre>
	 * 初始化三维视图线路
	 * </pre>
	 *
	 * @param subObjId
	 * @return
	 */
	@GetMapping(value = "/initViewLink",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "初始化三维视图线路", notes = "初始化三维视图线路")
	public CommonResponse initViewLink()
	{
		List<DaoCriteria> daoCriterias = new ArrayList<>();
		daoCriterias = buildViewDaoCriteria(daoCriterias);

//		User currUser = getUserInfo();
//		if (currUser != null)
//		{
//			Department department = currUser.getDepartment();
//			if (department != null)//部门用户
//			{
//				//通过当前登录用户orgCode过滤
//				daoCriterias = buildViewDaoCriteria(daoCriterias);
//			}else 
//			{
//				String compCode = CurUserCompanyCache.getInstance().getCurCompany(getUserId(), getToken());
//				if (compCode != null)
//				{
//					//查询本单位及子单位下所有部门
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.EQUAL.getName(), compCode));
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"*%"));
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"*%"));
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"-%"));
//					daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"-%"));
//				}else
//				{
//					//无orgCode条件，通过当前登录用户orgCode过滤
//					daoCriterias = buildViewDaoCriteria(daoCriterias);
//				}
//			}
//		}
		List<Link3DVo> linkVos = link3DVoService.findAll(daoCriterias);
		List<Link3DVo> link3DVosfilter = View3DHandler.getInstance()
				.linkDatafilter(linkVos);     //进行数据过滤
		List<Map<String, Object>> viewMap = View3DHandler.getInstance().buildViewJson(link3DVosfilter);
		return CommonResponseUtil.success(viewMap);
	}
	
	@SuppressWarnings("unchecked")
	@GetMapping(value = "/node/detail",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "获取节点详情", notes = "获取节点详情")
	public CommonResponse getNodeDetail(
			@ApiParam(value = "节点类型", required = true) @RequestParam String type,
			@ApiParam(value = "节点id", required = true) @RequestParam String id)
	{
		Map<String, Object> patrolInfoMap = null;
		if (type.equals(View3DNodeType.RISK.getName()))
		{
			Map<String, String> map = new HashMap<String, String>();
			map.put("pointID", id);
			Object object = remotePatrolServer.getPatrolInfo(map);
			LinkedHashMap<String, Object> patrolInfo = (LinkedHashMap<String, Object>)object;
			patrolInfoMap = View3DHandler.getInstance().buildPatrolInfo(patrolInfo);
			System.out.println(object);
		}
		return CommonResponseUtil.success(patrolInfoMap);
	}

	@SuppressWarnings("unchecked")
	@PostMapping(value = "/department/searchView",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "根据部门检索视图节点和线路", notes = "根据部门检索视图节点和线路")
	public CommonResponse getLinks(
			@ApiParam(value = "查询条件", required = false) @RequestBody(required = false) List<CommonRequest> queryRequests,
			@ApiParam(value = "分页参数", required = true) CommonPageable commonPageable)
	{
		Map<String, Object> resultMap = new HashMap<>();
		List<DaoCriteria> daoCriterias = new ArrayList<DaoCriteria>();
		/**
		 * 检索中分页查询线路信息
		 */
		CommonRequest dempCommonRequest = null;//部门过滤条件
		String orgCodeFilter = null;//部门过滤orgCode条件
		if (queryRequests != null && queryRequests.size() > 0)
		{
			for (CommonRequest commonRequest : queryRequests)
			{
				if (commonRequest.getName().equals("orgCode"))
				{
					dempCommonRequest = commonRequest;
					break;
				}
			}
			if (dempCommonRequest != null)
			{
				orgCodeFilter = dempCommonRequest.getValue().toString();
				queryRequests.remove(dempCommonRequest);
			}
		}
		List<DaoCriteria> queryDaoCriterias = buildDaoCriterias(queryRequests);
		if (orgCodeFilter != null)//有orgCode条件，则过滤
		{
			//添加所属部门的过滤条件
			daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.EQUAL.getName(), orgCodeFilter));
			daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), orgCodeFilter+",%"));
			daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+orgCodeFilter+",%"));
			daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+orgCodeFilter));
		}else 
		{
			daoCriterias = buildViewDaoCriteria(daoCriterias);
//			User currUser = getUserInfo();
//			if (currUser != null)
//			{
//				Department department = currUser.getDepartment();
//				if (department != null)//部门用户
//				{
//					//通过当前登录用户orgCode过滤
//					daoCriterias = buildViewDaoCriteria(daoCriterias);
//				}else 
//				{
//					String compCode = CurUserCompanyCache.getInstance().getCurCompany(getUserId(), getToken());
//					if (compCode != null)
//					{
//						//查询本单位及子单位下所有部门
//						daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.EQUAL.getName(), compCode));
//						daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"*%"));
//						daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"*%"));
//						daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"-%"));
//						daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"-%"));
//					}else
//					{
//						//无orgCode条件，通过当前登录用户orgCode过滤
//						daoCriterias = buildViewDaoCriteria(daoCriterias);
//					}
//				}
//			}
		}
		queryDaoCriterias.addAll(daoCriterias);
		Page<Link3DVo> searchLinkVos = link3DVoService.findAll(queryDaoCriterias, commonPageable);
		List<Map<String, Object>> viewMap = View3DHandler.getInstance().buildLinkSeachJson(searchLinkVos.getContent());
		Page<Map<String, Object>> viewMaps = new PageImpl<>(viewMap, commonPageable, searchLinkVos.getTotalElements());
		resultMap.put("listData", viewMaps);
		/**
		 * 查询视图中线路信息
		 */
		List<Link3DVo> linkVos = link3DVoService.findAll(daoCriterias);
		List<Link3DVo> link3DVosfilter = View3DHandler.getInstance().linkDatafilter(linkVos);     //进行数据过滤
		List<Map<String, Object>> viewLinkMap = View3DHandler.getInstance().buildViewJson(link3DVosfilter);
		resultMap.put("link", viewLinkMap);
		/**
		 * 查询巡检点信息
		 */
		List<Node3DVo> node3DVos = null;
		if (queryRequests.size() == 0)//无其他过滤条件
		{
			node3DVos = node3DVoService.findAll(daoCriterias);
		}else 
		{
			node3DVos = new ArrayList<>();
			List<String> routeIds = new ArrayList<>();
			for (Link3DVo link3DVo : linkVos)
			{
				routeIds.add(link3DVo.getOid());
			}
			if (routeIds.size() > 0)
			{
				
				Map<String, List<String>> map = new HashMap<String, List<String>>();
				map.put("routeIDs", routeIds);
				Object object = remotePatrolServer.getPointsByRouteId(map);
				if (object != null)
				{
					LinkedHashMap<String, Object> rountPointIds = (LinkedHashMap<String, Object>) object;
					List<DaoCriteria> nodeDaoCriterias = new ArrayList<DaoCriteria>();
					for (Object pointObject : rountPointIds.values())
					{
						List<String> pointIds = (List<String>) pointObject;
						for (Object pointId : pointIds)
						{
							nodeDaoCriterias.add(new DaoCriteria("oid", QueryOperatorEnum.EQUAL.getName(), pointId.toString()));
						}
					}
					
					node3DVos.addAll(node3DVoService.findAll(nodeDaoCriterias));
				}
			}
		}
		List<Node3DVo> node3DVosfilter = View3DHandler.getInstance().nodeDatafilter(node3DVos);  //进行数据过滤
		Map<String, List<Map<String, Object>>> viewNodeMap = View3DHandler.getInstance()
				.buildViewNodeJson(node3DVosfilter);
		List<Map<String, Object>> viewTypeList = viewNodeMap.get(View3DNodeType.RISK.getName());
		if (viewTypeList == null)
		{
			viewTypeList = new ArrayList<>();
		}
		Map<String, Object> maekerMap = new HashMap<>();
		maekerMap.put(View3DNodeType.RISK.getName(), viewTypeList);
		resultMap.put("points", maekerMap);
		return CommonResponseUtil.success(resultMap);
	}
	/**
	 * 
	 * <pre>
	 * 根据条件检索视图节点和链路
	 * </pre>
	 *
	 * @param type
	 * @param param
	 * @return
	 */
	@SuppressWarnings("unchecked")
	@GetMapping(value = "/link/searchView",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "根据线路检索视图节点和线路", notes = "根据条件检索视图节点和线路")
	public CommonResponse searchViewNodeAndLink(
			@ApiParam(value = "线路id", required = true) @RequestParam(required = true) String linkId)
	{
		Map<String, Object> resultMap = new HashMap<>();
		/**
		 * 查询线路信息
		 */
		List<Link3DVo> link3DVos = new ArrayList<>();
		Link3DVo link3DVo = link3DVoService.findOne(linkId);
		link3DVos.add(link3DVo);
		List<Link3DVo> link3DVosfilter = View3DHandler.getInstance().linkDatafilter(link3DVos);  //进行数据过滤
		List<Map<String, Object>> viewMap = View3DHandler.getInstance().buildViewJson(link3DVosfilter);
		resultMap.put("link", viewMap);
		/**
		 * 查询巡检点信息
		 */
		List<String> routeIds = new ArrayList<>();
		routeIds.add(link3DVo.getOid());
		Map<String, List<String>> map = new HashMap<String, List<String>>();
		map.put("routeIDs", routeIds);
		Object object = remotePatrolServer.getPointsByRouteId(map);
		if (object != null)
		{
			LinkedHashMap<String, Object> rountPointIds = (LinkedHashMap<String, Object>) object;
			List<DaoCriteria> daoCriterias = new ArrayList<DaoCriteria>();
			for (Object pointObject : rountPointIds.values())
			{
				List<String> pointIds = (List<String>) pointObject;
				for (Object pointId : pointIds)
				{
					daoCriterias.add(new DaoCriteria("oid", QueryOperatorEnum.EQUAL.getName(), pointId.toString()));
				}
			}
			List<Node3DVo> node3DVos = node3DVoService.findAll(daoCriterias);
			List<Node3DVo> node3DVosfilter = View3DHandler.getInstance().nodeDatafilter(node3DVos);  //进行数据过滤
			Map<String, List<Map<String, Object>>> viewNodeMap = View3DHandler.getInstance()
					.buildViewNodeJson(node3DVosfilter);
			List<Map<String, Object>> viewTypeList = viewNodeMap.get(View3DNodeType.RISK.getName());
			if (viewTypeList == null)
			{
				viewTypeList = new ArrayList<>();
			}
			Map<String, Object> maekerMap = new HashMap<>();
			maekerMap.put(View3DNodeType.RISK.getName(), viewTypeList);
			resultMap.put("points", maekerMap);
		}
		return CommonResponseUtil.success(resultMap);
	}
	/**
	 * 
	 * <pre>
	 * 同步巡检点和巡检线路对应的3D视图元素
	 * </pre>
	 *
	 * @return
	 */
	@SuppressWarnings("unchecked")
	@PostMapping(value = "/synchronous",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "同步巡检点和巡检线路对应的3D视图元素", notes = "同步巡检点和巡检线路对应的3D视图元素")
	//@Authorization(ingore = true)
	public CommonResponse synchronousPatrolData()
	{
		Object object = remotePatrolServer.initViewNode();
		logger.info("同步巡检点和巡检线路对应的3D视图元素："+JSONUtil.toJson(object));
		LinkedHashMap<String, Object> allData = (LinkedHashMap<String, Object>) object;
		//人员信息
		List<Node3DVo> perNode3DVos = node3DVoService.findByType(View3DNodeType.PERSON.getName());
		Set<String> userIdSet = new HashSet<>();
		Map<String, Node3DVo> perNode3DVoMap = new HashMap<>();
		for (Node3DVo node3dVo : perNode3DVos)
		{
			perNode3DVoMap.put(node3dVo.getOid(), node3dVo);
		}
		/**
		 * 同步巡检点信息
		 */
		Object pointsObj = allData.get("points");
		if (pointsObj != null)
		{
			List<Node3DVo> patrolNode3DVos = node3DVoService.findByType(View3DNodeType.RISK.getName());
			Map<String, Node3DVo> node3DVoMap = new HashMap<>();
			for (Node3DVo node3dVo : patrolNode3DVos)
			{
				node3DVoMap.put(node3dVo.getOid(), node3dVo);
			}
			List<LinkedHashMap<String, Object>> pointList = (List<LinkedHashMap<String, Object>>)pointsObj;
			for (LinkedHashMap<String, Object> linkedHashMap : pointList)
			{
				//更新保存巡检点对应的节点
				String oid = linkedHashMap.get("pointId") == null? "" : linkedHashMap.get("pointId").toString();
				Node3DVo patrolNode3dVo = node3DVoMap.get(oid);
				if (patrolNode3dVo ==null)
				{
					//巡检点无对应的3D节点，则进行新增
					patrolNode3dVo = new Node3DVo();
					patrolNode3dVo.setType(View3DNodeType.RISK.getName());
					patrolNode3dVo.setOid(oid);
				}else{
					node3DVoMap.remove(oid);
				}
				if (StringUtil.isNotEmpty(linkedHashMap.get("status")))
				{
					patrolNode3dVo.setNodeState(CheckStateEnum.getEnum(Integer.valueOf(linkedHashMap.get("status").toString())).getName());
				}
				patrolNode3dVo.setDisplayName(linkedHashMap.get("pointName") == null? null : linkedHashMap.get("pointName").toString());
				patrolNode3dVo.setTaskOid(linkedHashMap.get("taskId") == null? null : linkedHashMap.get("taskId").toString());
				patrolNode3dVo.setRemark(JSONUtil.toJson(linkedHashMap));
				Object configObj = linkedHashMap.get("config");
				if (configObj != null)
				{
					patrolNode3dVo.setConfig(JSONUtil.toJson(configObj));
				}
				String coordinates = linkedHashMap.get("coordinates") == null? null : linkedHashMap.get("coordinates").toString();//坐标点
				if (StringUtil.isNotEmpty(coordinates))
				{
					String[] xyz = coordinates.split(",");
					if (xyz.length == 3)
					{
						CoordDTO coordDTO = new CoordDTO();
						coordDTO.setX(Double.valueOf(xyz[0]));
						coordDTO.setY(Double.valueOf(xyz[1]));
						coordDTO.setZ(Double.valueOf(xyz[2]));
						patrolNode3dVo.setPosition(JSONUtil.toJson(coordDTO));
					}
				}
				//人员信息
				Object userObj = linkedHashMap.get("users");
				List<LinkedHashMap<String, Object>> pointPerList = (List<LinkedHashMap<String, Object>>)userObj;
				Set<String> orgCodeSet = new HashSet<>();
				StringBuilder stringBuilder = new StringBuilder();
				int i = 0;
				for (LinkedHashMap<String, Object> perLinkedHashMap : pointPerList)
				{
					String orgCode = savePerNode(perLinkedHashMap, perNode3DVoMap, userIdSet);
					if (StringUtil.isNotEmpty(orgCode) && !orgCodeSet.contains(orgCode))
					{
						if (i != 0)
						{
							stringBuilder.append(",");
						}
						stringBuilder.append(orgCode);
						i++;
						orgCodeSet.add(orgCode);
					}
				}
				//保存巡检点对应的3D节点
				patrolNode3dVo.setOrgCode(stringBuilder.toString());
				node3DVoService.save(patrolNode3dVo);
			}
			//删除无巡检点对应的节点
			for (Node3DVo remNode3DVo : node3DVoMap.values())
			{
				remNode3DVo.setIsDelete(true);
				node3DVoService.save(remNode3DVo);
			}
		}
		/**
		 * 同步线路信息
		 */
		Object routesObj = allData.get("routes");
		if (routesObj != null)
		{
			List<Link3DVo> link3DVoAll = link3DVoService.findAllInPathNull();
			Map<String, Link3DVo> link3DVoMap = new HashMap<>();
			for (Link3DVo link3DVo : link3DVoAll)
			{
				link3DVoMap.put(link3DVo.getOid(), link3DVo);
			}
			List<LinkedHashMap<String, Object>> routeList = (List<LinkedHashMap<String, Object>>)routesObj;
			for (LinkedHashMap<String, Object> linkedHashMap : routeList)
			{
				//更新保存巡检线路对应的链路
				if (linkedHashMap.get("routeId") == null)
				{
					continue;
				}
				String oid = linkedHashMap.get("routeId").toString();
				Link3DVo rountLink3DVo = link3DVoMap.get(oid);
				if (rountLink3DVo ==null)
				{
					//巡检线路无对应的3D链路，则进行新增
					rountLink3DVo = new Link3DVo();
					rountLink3DVo.setOid(oid);
				}else{
					link3DVoMap.remove(oid);
				}
				rountLink3DVo.setDisplayName(linkedHashMap.get("routeName") == null? null : linkedHashMap.get("routeName").toString());
				rountLink3DVo.setRemark(JSONUtil.toJson(linkedHashMap));
				//人员信息
				Object userObj = linkedHashMap.get("patrolUsers");
				List<LinkedHashMap<String, Object>> linkPerList = (List<LinkedHashMap<String, Object>>)userObj;
				Set<String> orgCodeSet = new HashSet<>();
				StringBuilder stringBuilder = new StringBuilder();
				int i = 0;
				for (LinkedHashMap<String, Object> perLinkedHashMap : linkPerList)
				{
					String orgCode = savePerNode(perLinkedHashMap, perNode3DVoMap, userIdSet);
					if (orgCode != null && !orgCodeSet.contains(orgCode))
					{
						if (i != 0)
						{
							stringBuilder.append(",");
						}
						stringBuilder.append(orgCode);
						orgCodeSet.add(orgCode);
						i++;
					}
				}
				//保存巡检线路对应的3D链路
				rountLink3DVo.setOrgCode(stringBuilder.toString());
				link3DVoService.save(rountLink3DVo);
			}
			//删除无巡检线路对应的链路
			for (Link3DVo remLink3DVo : link3DVoMap.values())
			{
				remLink3DVo.setIsDelete(true);
				link3DVoService.save(remLink3DVo);
			}
		}
		/**
		 * 同步巡检人员信息
		 */
		//删除无巡检人员对应的节点
		for (Node3DVo remNode3DVo : perNode3DVoMap.values())
		{
			remNode3DVo.setIsDelete(true);
			node3DVoService.save(remNode3DVo);
		}
		return CommonResponseUtil.success();
	}
	/**
	 * 
	 * <pre>
	 * 同步巡检线路对应的3D视图元素
	 * </pre>
	 *
	 * @return
	 */
	@PostMapping(value = "/synchronous/points",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "同步巡检点对应的3D视图元素", notes = "同步巡检点对应的3D视图元素")
	//@Authorization(ingore = true)
	public CommonResponse synchronousPatrolpoints(
			@ApiParam(value = "巡检点信息", required = true) @RequestBody List<PointInfoSyn3DRespone> pointInfoSyn3DRespones)
	{
		if (pointInfoSyn3DRespones == null)
		{
			return CommonResponseUtil.failure("参数为null");
		}
		logger.info("同步巡检点对应的3D视图元素,接收到巡检点数据："+JSONUtil.toJson(pointInfoSyn3DRespones));
		//人员信息
		Set<String> userIdSet = new HashSet<>();
		/**
		 * 同步巡检点信息
		 */
		for (PointInfoSyn3DRespone pointInfoSyn3DRespone : pointInfoSyn3DRespones)
		{
			//更新保存巡检点对应的节点
			String oid = pointInfoSyn3DRespone.getPointId();
			List<Node3DVo> patrolNode3dVos = node3DVoService.findByTypeAndOid(View3DNodeType.RISK.getName(), oid);
			Node3DVo patrolNode3dVo = null;
			if (patrolNode3dVos == null || patrolNode3dVos.size() != 1)
			{
				//巡检点无对应的3D节点，则进行新增
				patrolNode3dVo = new Node3DVo();
				patrolNode3dVo.setType(View3DNodeType.RISK.getName());
				patrolNode3dVo.setOid(oid);
			}else{
				patrolNode3dVo = patrolNode3dVos.get(0);
			}
			patrolNode3dVo.setNodeState(CheckStateEnum.getEnum(Integer.valueOf(pointInfoSyn3DRespone.getStatus())).getName());
			patrolNode3dVo.setDisplayName(pointInfoSyn3DRespone.getPointName());
			patrolNode3dVo.setIsDelete(pointInfoSyn3DRespone.getIsDelete());
			patrolNode3dVo.setRemark(JSONUtil.toJson(pointInfoSyn3DRespone));
			patrolNode3dVo.setOrgCode(pointInfoSyn3DRespone.getOrgCode());
			if (pointInfoSyn3DRespone.getNodeConfigDTO() != null)
			{
				patrolNode3dVo.setConfig(JSONUtil.toJson(pointInfoSyn3DRespone.getNodeConfigDTO()));
			}
			String coordinates = pointInfoSyn3DRespone.getCoordinates();//坐标点
			if (StringUtil.isNotEmpty(coordinates))
			{
				String[] xyz = coordinates.split(",");
				if (xyz.length == 3)
				{
					CoordDTO coordDTO = new CoordDTO();
					coordDTO.setX(Double.valueOf(xyz[0]));
					coordDTO.setY(Double.valueOf(xyz[1]));
					coordDTO.setZ(Double.valueOf(xyz[2]));
					patrolNode3dVo.setPosition(JSONUtil.toJson(coordDTO));
				}
			}
			//人员信息
			List<PatrolUserRespone> pointPerList =  pointInfoSyn3DRespone.getUsers();
			StringBuilder stringBuilder = new StringBuilder();
			if (pointPerList != null)
			{
				Set<String> orgCodeSet = new HashSet<>();
				int i = 0;
				for (PatrolUserRespone patrolUserRespone : pointPerList)
				{
					String orgCode = savePerNode(patrolUserRespone, userIdSet);
					if (StringUtil.isNotEmpty(orgCode) && !orgCodeSet.contains(orgCode))
					{
						if (i != 0)
						{
							stringBuilder.append(",");
						}
						stringBuilder.append(orgCode);
						i++;
						orgCodeSet.add(orgCode);
					}
				}
			}
			//保存巡检点对应的3D节点
			if (stringBuilder.length() > 0) {
				patrolNode3dVo.setOrgCode(stringBuilder.toString());
			}
			// 设置默认rotation和scale
			CoordDTO zeroCoordDTO = new CoordDTO();
			zeroCoordDTO.setX(0d);
			zeroCoordDTO.setY(0d);
			zeroCoordDTO.setZ(0d);
			patrolNode3dVo.setRotation(JSONUtil.toJson(zeroCoordDTO));
			patrolNode3dVo.setScale(JSONUtil.toJson(zeroCoordDTO));
			node3DVoService.save(patrolNode3dVo);
		}
		return CommonResponseUtil.success();
	}
	
	/**
	 * 线路同步
	 * @param routeResponseList
	 * @return
	 */
	@PostMapping(value = "/synchronous/routes",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "同步线路对应的3D视图元素", notes = "同步线路对应的3D视图元素")
	//@Authorization(ingore = true)
	public CommonResponse synchronousPatrolroutes(
			@ApiParam(value = "线路信息", required = true) @RequestBody List<RouteResponse> routeResponseList)
	{
		if (routeResponseList == null)
		{
			return CommonResponseUtil.failure("参数为null");
		}
		logger.info("同步线路对应的3D视图元素,接收到线路数据："+JSONUtil.toJson(routeResponseList));
		//人员信息
		List<Node3DVo> perNode3DVos = node3DVoService.findByType(View3DNodeType.PERSON.getName());
		Set<String> userIdSet = new HashSet<>();
		Map<String, Node3DVo> perNode3DVoMap = new HashMap<>();
		for (Node3DVo node3dVo : perNode3DVos)
		{
			perNode3DVoMap.put(node3dVo.getOid(), node3dVo);
		}
		/**
		 * 同步线路信息
		 */
		
			List<Link3DVo> link3DVoAll = link3DVoService.findAllInPathNull();
			Map<String, Link3DVo> link3DVoMap = new HashMap<>();
			for (Link3DVo link3DVo : link3DVoAll)
			{
				link3DVoMap.put(link3DVo.getOid(), link3DVo);
			}
			for (RouteResponse route : routeResponseList)
			{
				//更新保存巡检线路对应的链路
				if (route.getRouteId() == null)
				{
					continue;
				}
				String oid = route.getRouteId().toString();
				Link3DVo rountLink3DVo = link3DVoMap.get(oid);
				if (rountLink3DVo ==null)
				{
					//巡检线路无对应的3D链路，则进行新增
					rountLink3DVo = new Link3DVo();
					rountLink3DVo.setOid(oid);
				}else{
					link3DVoMap.remove(oid);
				}
				rountLink3DVo.setIsDelete(route.getIsDelete());
				rountLink3DVo.setOrgCode(route.getOrgCode());
				rountLink3DVo.setDisplayName(route.getRouteName() == null? null : route.getRouteName());
				rountLink3DVo.setRemark(JSONUtil.toJson(route));
				//人员信息
				List<PatrolUserRespone> patrolUsers = route.getPatrolUsers();
				Set<String> orgCodeSet = new HashSet<>();
				StringBuilder stringBuilder = new StringBuilder();
				int i = 0;
				for (PatrolUserRespone patrolUser : patrolUsers)
				{
					String orgCode = savePerNode(patrolUser, perNode3DVoMap, userIdSet);
					if (orgCode != null && !orgCodeSet.contains(orgCode))
					{
						if (i != 0)
						{
							stringBuilder.append(",");
						}
						stringBuilder.append(orgCode);
						orgCodeSet.add(orgCode);
						i++;
					}
				}
				//保存巡检线路对应的3D链路
				if (stringBuilder.length() > 0) {
					rountLink3DVo.setOrgCode(stringBuilder.toString());
				}
				link3DVoService.save(rountLink3DVo);
			}
		return CommonResponseUtil.success();
	}
	
	/**
	 * 
	 * <pre>
	 * 保存巡检人员对应的巡检节点
	 * </pre>
	 *
	 * @param linkedHashMap 巡检人员信息
	 * @param node3DVoMap 已有的巡检人员节点
	 * @param userIdSet 已更新的人员
	 * @return 返回人员的orgCode
	 */
	private String savePerNode(LinkedHashMap<String, Object> linkedHashMap, 
			Map<String, Node3DVo> perNode3DVoMap, Set<String> userIdSet)
	{
		//更新保存巡检点对应的节点
		String oid = linkedHashMap.get("userId") == null? "" : linkedHashMap.get("userId").toString();
		String orgCode = linkedHashMap.get("orgCode") == null? null : linkedHashMap.get("orgCode").toString();
		if (userIdSet.contains(oid))
		{
			return orgCode;
		}
		Node3DVo perNode3dVo = perNode3DVoMap.get(oid);
		if (perNode3dVo ==null)
		{
			//巡检人员无对应的3D节点，则进行新增
			perNode3dVo = new Node3DVo();
			perNode3dVo.setType(View3DNodeType.PERSON.getName());
			perNode3dVo.setOid(oid);
		}else{
			perNode3DVoMap.remove(oid);
		}
		perNode3dVo.setDisplayName(linkedHashMap.get("userName") == null? null : linkedHashMap.get("userName").toString());
		perNode3dVo.setOrgCode(orgCode);
		node3DVoService.save(perNode3dVo);
		userIdSet.add(oid);
		return orgCode;
	}
	
	
	private String savePerNode(PatrolUserRespone patrolUser, 
			Map<String, Node3DVo> perNode3DVoMap, Set<String> userIdSet)
	{
		//更新保存巡检点对应的节点
		String oid = patrolUser.getUserId()== null? "" : patrolUser.getUserId();
		String orgCode = patrolUser.getOrgCode() == null? null : patrolUser.getOrgCode();
		if (userIdSet.contains(oid))
		{
			return orgCode;
		}
		Node3DVo perNode3dVo = perNode3DVoMap.get(oid);
		if (perNode3dVo ==null)
		{
			//巡检人员无对应的3D节点，则进行新增
			perNode3dVo = new Node3DVo();
			perNode3dVo.setType(View3DNodeType.PERSON.getName());
			perNode3dVo.setOid(oid);
		}else{
			perNode3DVoMap.remove(oid);
		}
		perNode3dVo.setDisplayName(patrolUser.getUserName() == null? null : patrolUser.getUserName());
		perNode3dVo.setOrgCode(orgCode);
		node3DVoService.save(perNode3dVo);
		userIdSet.add(oid);
		return orgCode;
	}
	/**
	 * 
	 * <pre>
	 * 保存巡检人员对应的巡检节点
	 * </pre>
	 *
	 * @param patrolUserRespone 巡检人员信息
	 * @param userIdSet 已更新的人员
	 * @return 返回人员的orgCode
	 */
	private String savePerNode(PatrolUserRespone patrolUserRespone, Set<String> userIdSet)
	{
		//更新保存巡检点对应的节点
		String oid = patrolUserRespone.getUserId();
		String orgCode = patrolUserRespone.getOrgCode();
		if (userIdSet.contains(oid))
		{
			return orgCode;
		}
		List<Node3DVo> perNode3dVos = node3DVoService.findByTypeAndOid(View3DNodeType.PERSON.getName(), oid);
		Node3DVo perNode3dVo = null;
		if (perNode3dVos ==null || perNode3dVos.size() != 1)
		{
			//巡检人员无对应的3D节点，则进行新增
			perNode3dVo = new Node3DVo();
			perNode3dVo.setType(View3DNodeType.PERSON.getName());
			perNode3dVo.setOid(oid);
		}else{
			perNode3dVo = perNode3dVos.get(0);
		}
		perNode3dVo.setDisplayName(patrolUserRespone.getUserName());
		perNode3dVo.setOrgCode(orgCode);
		node3DVoService.save(perNode3dVo);
		userIdSet.add(oid);
		return orgCode;
	}
	/**
	 * 
	 * <pre>
	 * 构建3D视图当前用户orgCode过滤条件（适应于Node3DVo和Link3DVo中拼接的orgCode）
	 * </pre>
	 *
	 * @return
	 */
	private List<DaoCriteria> buildViewDaoCriteria(List<DaoCriteria> daoCriterias) 
	{
//		User currUser = getUserInfo();
//		if (currUser != null)
//		{
//			Company company = currUser.getCompany();
//			Department department = currUser.getDepartment();
//			String compCode = company.getCompCode();
//			if (department == null)
		ReginParams currUser = getSelectedOrgInfo();
		if (currUser != null)
		{
			CompanyBo company = currUser.getCompany();
			DepartmentBo department = currUser.getDepartment();
			Long compCode = company.getCompanyOrgCode();
			if (department == null)
			{
				//单位用户，查询本单位及子单位下所有部门
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.EQUAL.getName(), compCode));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"*%"));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"*%"));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"-%"));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"-%"));
			}else 
			{
				//部门用户,查询当前部门
				String orgCode = company.getCompanyOrgCode()+"-"+department.getDeptOrgCode();
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.EQUAL.getName(), orgCode));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), orgCode+",%"));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+orgCode+",%"));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+orgCode));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), compCode+"*%"));
				daoCriterias.add(new DaoCriteria("orgCode", QueryOperatorEnum.LIKE.getName(), "%,"+compCode+"*%"));
			}
		}
		return daoCriterias;
	}
}
