package com.yeejoin.amos.safety.business.controller;

import com.yeejoin.amos.safety.business.dao.mapper.View3DMapper;
import com.yeejoin.amos.safety.business.vo.CommonPageable;
import com.yeejoin.amos.safety.business.vo.CommonResponse;
import com.yeejoin.amos.safety.business.vo.CommonResponseUtil;
import com.yeejoin.amos.safety.business.vo.ReginParams;
import com.yeejoin.amos.safety.common.cache.CurUserCompanyCache;
import com.yeejoin.amos.safety.common.enums.CheckStateEnum;
import com.yeejoin.amos.safety.common.enums.View3DNodeType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;
import org.codehaus.jackson.map.ObjectMapper;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 
 * <pre>
 * 巡检Controller
 * </pre>
 *
 * @author amos
 * @version $Id: PatrolController.java, v 0.1 2018年12月3日 下午5:12:27 amos Exp $
 */
@RestController
@RequestMapping(value = "/view3d")
@Api(value = "view3d", tags = { "3d数据检索" })
public class View3DDataController extends BaseController
{



	private static final Logger logger = Logger.getLogger(View3DDataController.class);


	@Autowired
	private View3DMapper view3DMapper;

	ObjectMapper objectMapper = new ObjectMapper();


	//@Authorization(ingore = true)
	@GetMapping(value = "/3ddata/all",produces = "application/json;charset=UTF-8")
	@ApiOperation(value = "实景右侧边栏搜索", notes = "实景右侧边栏搜索")
	public CommonResponse saveCurrCompany(
			@RequestParam(required = false) String type,
			@RequestParam(required = false) String inputText,
			@RequestParam(required = false) String routeName,
			@RequestParam(required = false) String protectObjName,
			@RequestParam(required = false) String dataLevel,
			@RequestParam(required = false) String nodeState,
			@RequestParam(required = true) int current,
			@RequestParam(required = true) int pageSize) throws Exception
	{
		String orgCode = null;
		ReginParams currUser = getSelectedOrgInfo();
		if (currUser != null)
		{
				//获取当前用户所选单位
			String compCode  = currUser.getCompany().getOrgCode();
//			if (compCode != null)
//			{
//				//查询本单位及子单位下所有部门
//				Company company = currUser.getCompany();
//				orgCode = company.getCompCode();
//			}else
//			{
//				//无orgCode条件，通过当前登录用户orgCode过滤
//				orgCode = currUser.getOrgCode();
//			}
		}

		CommonPageable pageable = new CommonPageable( current,  pageSize);
		if("fireResource".equals(type)){
			type = "hydrant,pool,fireCar,fireEquipment,fireChamber,fireFoamRoom";

		}else if("water".equals(type)){
			type = "hydrant,pool";
		}
		long count =  view3DMapper.query3dDataPageCount(
				StringUtils.trimToNull(type),
				StringUtils.trimToNull(inputText),
				StringUtils.trimToNull(routeName),
				StringUtils.trimToNull(protectObjName),
				StringUtils.trimToNull(dataLevel),StringUtils.trimToNull(orgCode),StringUtils.trimToNull(nodeState));

		List<Map<String,Object>> mapList = view3DMapper.query3dDataPage(StringUtils.trimToNull(type),StringUtils.trimToNull(inputText),
				StringUtils.trimToNull(routeName),
				StringUtils.trimToNull(protectObjName),
				StringUtils.trimToNull(dataLevel),StringUtils.trimToNull(orgCode),StringUtils.trimToNull(nodeState),pageable.getOffset(),pageable.getPageSize());
		List<Map<String,Object>> newList = new ArrayList<Map<String,Object>>();
		if(!CollectionUtils.isEmpty(mapList))
		{
			for(Map<String,Object> map: mapList)
			{
				Map newMap  = new HashMap();
				Map<String,Object>  rotation 	= new HashMap<>();
				Map<String,Object>  config 		= new HashMap<>();
				Map<String,Object>  position 	= new HashMap<>();
				Map<String,Object>  scale 		= new HashMap<>();

				if(!StringUtils.isEmpty(String.valueOf(map.get("rotation"))))
					rotation 	= objectMapper.readValue(String.valueOf(map.get("rotation")),Map.class);
				if(!StringUtils.isEmpty(String.valueOf(map.get("config"))))
				config 			= objectMapper.readValue(String.valueOf(map.get("config")),Map.class);
				if(!StringUtils.isEmpty(String.valueOf(map.get("position"))))
					position 	= objectMapper.readValue(String.valueOf(map.get("position")),Map.class);
				if(!StringUtils.isEmpty(String.valueOf(map.get("scale"))) )
					scale 		= objectMapper.readValue(String.valueOf(map.get("scale")),Map.class);

				if (!ObjectUtils.isEmpty(map.get("remark"))) {
					JSONObject remark = new JSONObject(map.get("remark").toString());
					JSONArray jsonArr = remark.getJSONArray("users"); 
					if (!ObjectUtils.isEmpty(jsonArr)) {
						StringBuffer person = new StringBuffer();
						for (int i = 0; i < jsonArr.length(); i++) {
							JSONObject userObj = jsonArr.getJSONObject(i);
							if (userObj.has("userName")) {
								person.append(userObj.get("userName") + ",");
							}
						}
						if (person.length() > 0 && person.toString().endsWith(",")) {
							newMap.put("person", person.toString().substring(0, person.lastIndexOf(",")));
						}
					}
				}
				if(View3DNodeType.RISK.getName().equals(map.get("type"))){
					int le =  CheckStateEnum.getEnum(map.get("node_state").toString()).getValue();
					newMap.put("level",le);
					newMap.put("levelStr", "level_"+le);//前端用于过滤几倍级别
				}else{
					newMap.put("level",map.get("data_level"));
				}
				newMap.put("rotation",rotation);
				newMap.put("objKey",config.get("belongObjModel"));
				newMap.put("inDoor",config.get("isIndoor"));
				newMap.put("scale",scale);
				newMap.put("label",map.get("display_name"));
				newMap.put("code",map.get("data_code"));
				newMap.put("title",map.get("node_state"));
				newMap.put("routeName",map.get("route_name"));				
				newMap.put("type",map.get("type"));
				newMap.put("typeName",map.get("typeName"));
				newMap.put("displayIcon",map.get("display_icon"));
				newMap.put("id",map.get("oid"));
				newMap.put("position",position);
				newMap.put("levelStr","level_"+String.valueOf(map.get("data_level")));
				newMap.put("key",map.get("id"));
				newList.add(newMap);
			}
		}



		Page result = new PageImpl(newList,pageable,count);
		return CommonResponseUtil.success(result);
	}

}
