package com.yeejoin.amos.safety.business.dao.repository;

import java.util.List;

import org.springframework.stereotype.Repository;

import com.yeejoin.amos.safety.business.service.IBaseRepository;
import com.yeejoin.amos.safety.common.entity.Node3DVo;


/**
 * 
 * <pre>
 * 三维视图节点dao
 * </pre>
 *
 * @author amos
 * @version $Id: INode3DVoRepository.java, v 0.1 2018年11月28日 下午6:07:42 amos Exp $
 */
@Repository
public interface INode3DVoRepository extends IBaseRepository<Node3DVo, String> 
{
	
	/**
	 * 
	 * <pre>
	 * 根据节点类型类型查询视图节点
	 * </pre>
	 *
	 * @param type
	 * @return
	 */
	List<Node3DVo> findByType(String type);
	
	/**
	 * 
	 * <pre>
	 * 根据业务id和节点类型查询视图节点
	 * </pre>
	 *
	 * @param type
	 * @param oid
	 * @return
	 */
	List<Node3DVo> findByTypeAndOid(String type, String oid);
}
