package com.yeejoin.amos.safety.business.service.impl;

import java.util.List;

import org.springframework.stereotype.Service;
import com.yeejoin.amos.safety.business.dao.repository.INode3DVoRepository;
import com.yeejoin.amos.safety.business.service.INode3DVoService;
import com.yeejoin.amos.safety.common.entity.Node3DVo;

/**
 * 
 * <pre>
 * 三维视图节点service实现
 * </pre>
 *
 * @author amos
 * @version $Id: Node3DVoServiceImpl.java, v 0.1 2018年11月28日 下午6:12:21 amos Exp
 *          $
 */
@Service
public class Node3DVoServiceImpl extends GenericManagerImpl<Node3DVo, String>
		implements INode3DVoService
{
	INode3DVoRepository node3DVoRepository;
	
	public Node3DVoServiceImpl(INode3DVoRepository repository)
	{
		super(repository);
		this.node3DVoRepository = repository;
	}
	
	@Override
	public List<Node3DVo> findByType(String type)
	{
		return node3DVoRepository.findByType(type);
	}

	@Override
	public List<Node3DVo> findByTypeAndOid(String type, String oid)
	{
		return node3DVoRepository.findByTypeAndOid(type, oid);
	}

}