package com.yeejoin.amos.safety.common.cache;

import java.util.HashMap;
import java.util.Map;
/**
 * 
 * <pre>
 * 当前登录用户单位信息缓存
 * </pre>
 *
 * @author amos
 * @version $Id: CurUserCompanyCache.java, v 0.1 2018年12月29日 下午3:37:55 amos Exp $
 */
public class CurUserCompanyCache
{
	
	private static CurUserCompanyCache instance;
	//当前登录用户选择的单位的orgCode，第一个key为当前登录userId，第二个key为本次登录token
	private Map<Long, Map<String, String>> curCompanyMap = new HashMap<Long, Map<String, String>>();
	
	
	public static CurUserCompanyCache getInstance()
	{
		if (instance ==null)
		{
			instance = new CurUserCompanyCache();
		}
		return instance;
	}
	
	/**
	 * 
	 * <pre>
	 * 缓存当前登录单位信息
	 * </pre>
	 *
	 * @param userId
	 * @param token
	 * @param company
	 */
	public void putCurCompanyMap(Long userId, String token, String orgCode)
	{
		Map<String, String> token_company = new HashMap<String, String>();
		token_company.put(token, orgCode);
		//一个用户只保存最新的登录信息
		curCompanyMap.put(userId, token_company);
	}

	/**
	 * 
	 * <pre>
	 * 获取当前登录单位信息
	 * </pre>
	 *
	 * @param userId
	 * @param token
	 * @return
	 */
	public String getCurCompany(Long userId, String token)
	{
		String orgCode = null;
		Map<String, String> token_company = curCompanyMap.get(userId);
		if (token_company != null)
		{
			orgCode = token_company.get(token);
		}
		return orgCode;
	}
	
}
