package com.yeejoin.amos.safety.common.cache;

import java.util.HashMap;
import java.util.Map;

import com.yeejoin.amos.safety.common.entity.dto.CoordDTO;
/**
 * 
 * <pre>
 * 巡检人员上一次巡检位置信息缓存
 * </pre>
 *
 * @author amos
 * @version $Id: UserPostionCache.java, v 0.1 2019年1月6日 下午8:34:42 amos Exp $
 */
public class UserPostionCache
{
	
	private static UserPostionCache instance;
	//key为userId， value为巡检人上一次巡检位置
	private Map<String, CoordDTO> postionMap = new HashMap<String, CoordDTO>();
	
	
	public static UserPostionCache getInstance()
	{
		if (instance ==null)
		{
			instance = new UserPostionCache();
		}
		return instance;
	}
	
	/**
	 * 
	 * <pre>
	 * 缓存用户上一次巡检位置
	 * </pre>
	 *
	 * @param userId
	 * @param CoordDTO
	 */
	public void putPostionMap(String userId, CoordDTO CoordDTO)
	{
		postionMap.put(userId, CoordDTO);
	}

	/**
	 * 
	 * <pre>
	 * 获取用户上一次巡检位置
	 * </pre>
	 *
	 * @param userId
	 * @return
	 */
	public CoordDTO getPostionMap(String userId)
	{
		return postionMap.get(userId);
	}
	
}
