package com.yeejoin.amos.safety.common.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Where;

import com.alibaba.fastjson.JSON;
import com.yeejoin.amos.safety.business.response.RouteResponse;
import com.yeejoin.amos.safety.common.entity.dto.LinkPathDTO;

/**
 * 
 * <pre>
 * 三维视图链路元素
 * </pre>
 *
 * @author amos
 * @version $Id: Link3DVo.java, v 0.1 2018年11月28日 下午6:23:07 amos Exp $
 */
@Entity
@Table(name = "toip_biz_link3dvo")
@Where(clause="is_delete=0")//表示未删除的数据
public class Link3DVo extends BusinessEntity
{
	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = 3610831106560740034L;
	
	/**
	 * id
	 */
	@Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
	@Column(name = "id", nullable = false, length = 36)
	protected String id;
	/**
	 * 显示名
	 */
	@Column(name = "display_name")
	private String displayName;
	/**
	 * 类型
	 */
	@Column(name = "type")
	private String type;
	/**
	 * 所属对象Id
	 */
	@Column(name = "oid")
	private String oid;
	/**
	 * 线路路径
	 */
	@Column(name = "path")
	private String path;
	/**
	 * 组织机构（公司+部门），多个通过“，”进行隔开
	 */
	@Column(name = "org_code", length = 50)
	private String orgCode;
	
	/**
	 * 备注
	 */
	@Column(name = "remark")
	private String remark;
	
	/**
	 * 线路业务信息
	 */
	@Transient
	private RouteResponse routeResponse;
	
	/**
	 * 线路路径
	 */
	@Transient
	private LinkPathDTO linkPathDTO;
	
	
	public String getId()
	{
		return id;
	}
	public void setId(String id)
	{
		this.id = id;
	}
	public String getDisplayName()
	{
		return displayName;
	}
	public void setDisplayName(String displayName)
	{
		this.displayName = displayName;
	}
	public String getType()
	{
		return type;
	}
	public void setType(String type)
	{
		this.type = type;
	}
	
	public String getOid()
	{
		return oid;
	}
	public void setOid(String oid)
	{
		this.oid = oid;
	}
	public String getPath()
	{
		return path;
	}
	public void setPath(String path)
	{
		this.path = path;
	}
	
	public String getOrgCode()
	{
		return orgCode;
	}
	public void setOrgCode(String orgCode)
	{
		this.orgCode = orgCode;
	}
	public String getRemark()
	{
		return remark;
	}
	public void setRemark(String remark)
	{
		this.remark = remark;
	}
	
	public LinkPathDTO getLinkPathDTO()
	{
		return JSON.parseObject(path, LinkPathDTO.class);
	}
	public void setLinkPathDTO(LinkPathDTO linkPathDTO)
	{
		this.linkPathDTO = linkPathDTO;
	}
	public RouteResponse getRouteResponse()
	{
		return JSON.parseObject(remark, RouteResponse.class);
	}
	public void setRouteResponse(RouteResponse routeResponse)
	{
		this.routeResponse = routeResponse;
	}
	
}
 