package com.yeejoin.amos.safety.common.entity;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.yeejoin.amos.safety.business.vo.DateUtil;


/**
 * 
 * <pre>
 * 三维节点与规则日志实体视图
 * </pre>
 *
 * @author amos
 * @version $Id: NodeToipLogView.java, v 0.1 2019年1月2日 下午2:40:14 amos Exp $
 */
@Entity
@Table(name = "toip_biz_log")
public class NodeToipLogView implements Serializable
{

	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = -4633712954902787071L;

	@Id
	private String id;
	/**
	 * 时间
	 */
	private Date time = new Date();

	@Transient
	private String timeStr;
	/**
	 * 内容
	 */
	private String context;
	/**
	 * 类型
	 */
	private String type;
	/**
	 * 业务id
	 */
	private String bizId;
	/**
	 * 业务员实体名，例如com.yeejoin.amos.toip.bizrulebridge.entity.Fire
	 */
	private String bizclassName;
	/**
	 * 动作id
	 */
	private String actionId;
	/**
	 * ip
	 */
	private String ip;
	/**
	 * 结果
	 */
	private String result;
	/**
	 * 备注
	 */
	private String remark;
	/**
	 * 组织机构（公司+部门），多个通过“，”进行隔开
	 */
	private String orgCode;

	public String getId()
	{
		return id;
	}

	public void setId(String id)
	{
		this.id = id;
	}
	
	public Date getTime()
	{
		return time;
	}

	public void setTime(Date time)
	{
		this.time = time;
	}

	public String getContext()
	{
		return context;
	}

	public void setContext(String context)
	{
		this.context = context;
	}

	public String getType()
	{
		return type;
	}

	public void setType(String type)
	{
		this.type = type;
	}

	public String getBizId()
	{
		return bizId;
	}

	public void setBizId(String bizId)
	{
		this.bizId = bizId;
	}

	public String getIp()
	{
		return ip;
	}

	public void setIp(String ip)
	{
		this.ip = ip;
	}

	public String getResult()
	{
		return result;
	}

	public void setResult(String result)
	{
		this.result = result;
	}

	public String getRemark()
	{
		return remark;
	}

	public void setRemark(String remark)
	{
		this.remark = remark;
	}

	public String getActionId()
	{
		return actionId;
	}

	public void setActionId(String actionId)
	{
		this.actionId = actionId;
	}

	public String getTimeStr()
	{
		return DateUtil.getDateTimeFormat(this.time);
	}

	public String getBizclassName()
	{
		return bizclassName;
	}

	public void setBizclassName(String bizclassName)
	{
		this.bizclassName = bizclassName;
	}

	public String getOrgCode()
	{
		return orgCode;
	}

	public void setOrgCode(String orgCode)
	{
		this.orgCode = orgCode;
	}

}
