package com.yeejoin.amos.safety.common.entity;

import java.util.Date;
import java.util.List;

import com.yeejoin.amos.safety.business.vo.DateUtil;
import com.yeejoin.amos.safety.common.entity.dto.PatrolCheckInputDTO;
/**
 * 
 * <pre>
 * 风险点
 * </pre>
 *
 * @author amos
 * @version $Id: RiskPoint.java, v 0.1 2019年1月4日 上午9:27:20 amos Exp $
 */
public class RiskPoint 
{

	/**
	 * 风险点信息
	 */
	// 风险点id
	private int pointID;
	// 风险点编号
	private String pointNo;
	// 风险点名称
	private String pointName;
	// 风险点地址
	private String address;
	// 风险点状态：是否合格
	private String status;
	/**
	 * 风险点巡检信息
	 */
	// 记录编号
	private int checkID;
	// 巡检人编号
	private int userID;
	// 巡检时间
	private Date checkTime;
	// 巡检计划
	private String planName;
	// 巡检人
	private String userName;
	// 电话
	private String telephone;
	// 部门
	private String department;
	//巡检项
	private List<PatrolCheckInputDTO> checkInput;
	/**
	 * 任务信息
	 */
	// 任务编号
	private int taskID;
	// 任务名称
	private String taskName;
	// 安排人
	private String arranger;
	// 执行人
	private String executor;
	// 要求完成时间
	private Date planTime;
	// 要求完成时间
	private String planTimeStr;
	// 任务内容
	private String content;
	// 完成时间
	private Date fishTime;
	
	public int getCheckID()
	{
		return checkID;
	}
	public void setCheckID(int checkID)
	{
		this.checkID = checkID;
	}
	public int getUserID()
	{
		return userID;
	}
	public void setUserID(int userID)
	{
		this.userID = userID;
	}
	public int getPointID()
	{
		return pointID;
	}
	public void setPointID(int pointID)
	{
		this.pointID = pointID;
	}
	public String getPointNo()
	{
		return pointNo;
	}
	public void setPointNo(String pointNo)
	{
		this.pointNo = pointNo;
	}
	public String getPointName()
	{
		return pointName;
	}
	public void setPointName(String pointName)
	{
		this.pointName = pointName;
	}
	public Date getCheckTime()
	{
		return checkTime;
	}
	public void setCheckTime(Date checkTime)
	{
		this.checkTime = checkTime;
	}
	public String getAddress()
	{
		return address;
	}
	public void setAddress(String address)
	{
		this.address = address;
	}
	public String getStatus()
	{
		return status;
	}
	public void setStatus(String status)
	{
		this.status = status;
	}
	public String getPlanName()
	{
		return planName;
	}
	public void setPlanName(String planName)
	{
		this.planName = planName;
	}
	public String getUserName()
	{
		return userName;
	}
	public void setUserName(String userName)
	{
		this.userName = userName;
	}
	public String getTelephone()
	{
		return telephone;
	}
	public void setTelephone(String telephone)
	{
		this.telephone = telephone;
	}
	public String getDepartment()
	{
		return department;
	}
	public void setDepartment(String department)
	{
		this.department = department;
	}
	
	public List<PatrolCheckInputDTO> getCheckInput()
	{
		return checkInput;
	}
	public void setCheckInput(List<PatrolCheckInputDTO> checkInput)
	{
		this.checkInput = checkInput;
	}
	public int getTaskID()
	{
		return taskID;
	}
	public void setTaskID(int taskID)
	{
		this.taskID = taskID;
	}
	public String getTaskName()
	{
		return taskName;
	}
	public void setTaskName(String taskName)
	{
		this.taskName = taskName;
	}
	public String getArranger()
	{
		return arranger;
	}
	public void setArranger(String arranger)
	{
		this.arranger = arranger;
	}
	public String getExecutor()
	{
		return executor;
	}
	public void setExecutor(String executor)
	{
		this.executor = executor;
	}
	public Date getPlanTime()
	{
		return planTime;
	}
	public void setPlanTime(Date planTime)
	{
		this.planTime = planTime;
	}
	public String getPlanTimeStr()
	{
		if (planTime != null)
		{
			return DateUtil.date2LongStr(planTime);
		}
		return planTimeStr;
	}
	public void setPlanTimeStr(String planTimeStr)
	{
		this.planTimeStr = planTimeStr;
	}
	public String getContent()
	{
		return content;
	}
	public void setContent(String content)
	{
		this.content = content;
	}
	public Date getFishTime()
	{
		return fishTime;
	}
	public void setFishTime(Date fishTime)
	{
		this.fishTime = fishTime;
	}
	
}
