package com.yeejoin.amos.safety.core.remote.service;

import javax.servlet.http.HttpServletRequest;

import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import feign.RequestInterceptor;
import feign.RequestTemplate;

public class FeignBasicAuthRequestInterceptor implements RequestInterceptor{
	 public FeignBasicAuthRequestInterceptor() {

	    }

	    @Override
	    public void apply(RequestTemplate template) {
	    	ServletRequestAttributes attributes = (ServletRequestAttributes)RequestContextHolder.getRequestAttributes();
	        HttpServletRequest request = attributes.getRequest();
			
			String authToken = request.getHeader("X-Access-Token");
			String appKey = request.getHeader("appKey");
			String product = request.getHeader("product");
			if (authToken == null)
			{
				authToken = request.getParameter("token");
			}
	        template.header("toke", authToken);
	        template.header("X-Access-Token", authToken);
	        template.header("product", product);
	        template.header("appKey", appKey);
	    }
}
